# Wstęp
Celem tego laboratorium jest zaznajomienie z obsługą systemu operacyjnego Linux oraz tworzenie oprogramowania dla systemów wykorzystujących urządzenia peryferyjne (np. diody LED, przyciski, czytnik NFC, czujniki wielofunkcyjne) oraz urządzenia do komunikacji bezprzewodową.
Laboratorium podzielone jest na części. Ćwiczenia należy wykonywać w ustalonej kolejności, ponieważ w każdym kolejnym ćwiczeniu wykorzystywane sa elementy z ćwiczeń poprzedzających.
## Laboratorium 0
**Opis**: W tym ćwiczeniu należy na swoim komputerze zainstalować środowisko Visual Studio Code, które będzie podstawowym narzędziem do zdalnej pracy na komputerze jedno-układowym z zainstalowanym środowiskiem Linux.

**Instrukcja**: [lab00/README.md](lab00/README.md)

**Wynik**: Po wykonaniu tego ćwiczenia uczestnik kursu będzie posiadał narzędzia i umiejętności do zdalnej pracy z komputerem jedno-układowym z systemem Linux (tworzenie katalogów/plików/repozytorium git/oprogramowania)

## Laboratorium 1
**Opis**: W tym ćwiczeniu należy stworzyć prosty program do obsługi portów GPIO, a następnie skonfigurować serwer "message brokera MQTT" do sterowania GPIO. Ponadto należy utworzyć skrypt startowy dla własnych aplikacji.

**Instrukcja**: [lab01/README.md](lab01/README.md)

**Wynik**: Po wykonaniu tego ćwiczenia uczestnik kursu będzie posiadał wiedzę na temat tworzenia programów w języku python sterujących portami GPIO oraz wykorzystania kontenerów (Docker) do uruchamiania innych serwisów/aplikacji oraz obsługę wiadomości MQTT oraz jak utworzyć skrypt startowy wykorzystujący multiplekser terminala "tmux".

## Laboratorium 2
**Opis**: W tym ćwiczeniu należy stworzyć aplikację wykorzystującą wielofunkcyjny sensor BME280. Ponadto wykorzystany zostanie zbiór oprogramowania do automatycznego zbierania, archiwizacji oraz wizualizacji danych pomiarowych.

**Instrukcja**: [lab02/README.md](lab02/README.md)

**Wynik**: Po wykonaniu tego ćwiczenia uczestnik kursu będzie posiadał wiedzę na temat obsługi czujników pomiarowych w systemie Linux (Linux Industrial I/O Subsystem) oraz wykorzystania zbioru oprogramowania Telegraf+InfluxDB+Grafana do wyświetlania wyników pomiarowych.

## Laboratorium 3
**Opis**: W tym ćwiczeniu należy stworzyć aplikację wykorzystującą czytnik RFID. 

**Instrukcja**: [lab03/README.md](lab03/README.md)

**Wynik**: Po wykonaniu tego ćwiczenia uczestnik kursu będzie posiadał wiedzę na temat technologi RFID.

## Laboratorium 4
**Opis**: W tym ćwiczeniu należy stworzyć oprogramowanie dla mikro-kontrolera Nordic nRF52 wykorzystujące sensors BME280 oraz transmisje WiFi.  

**Instrukcja**: [lab04/README.md](lab04/README.md)

**Wynik**: Po wykonaniu tego ćwiczenia uczestnik kursu będzie posiadał wiedzę na temat tworzenia oprogramowania dla systemu czasu rzeczywistego uruchomionego na platformie nRF52. 

## Laboratorium 5
**Opis**: W tym ćwiczeniu należy stworzyć oprogramowanie dla mikro-kontrolera Nordic nRF52 wykorzystujące czytnik RFID oraz transmisje BLE.  

**Instrukcja**: [lab05/README.md](lab05/README.md)

**Wynik**: Po wykonaniu tego ćwiczenia uczestnik kursu będzie posiadał wiedzę na temat tworzenia oprogramowania dla systemu czasu rzeczywistego uruchomionego na platformie nRF52. 





