## Czytnik NFC

Sprawdz switch 
![Schemat połączenia czytnika NFC z NUC](lab03-i2c/img/lab2_nfc.png "Schemat połączenia czytnika NFC z NUC")
- Sprawdzenie poprawnej komunikacji z NF532 na magistrali I2C
```bash
modprobe i2c_dev
i2cdetect -y -r 9
cat /etc/nfc/libnfc.conf
nfc-list
nfc-poll
``` 
Zawartość pliku /etc/nfc/libnfc.conf
````bash
device.name = "PN532 over I2C"
device.connstring = "pn532_i2c:/dev/i2c-9"
````
Po uruchomieniu komendy 'nfc-pool' przyłóż kartę NFC do czytnika (włącz obracanie ramienia z kartami NFC), powinien wyświetlić się UID karty.
![Test połączenia czytnika NFC z NUC](lab03-i2c/img/PN532_testS.gif "Test połączenia czytnika NFC z NUC")

### Obsługa czytnika w Pythonie:
- Instalacja biblioteki py532lib:
```bash
source virtenv/bin/activate
pip install py532lib
``` 

- Przykładowy kod programu (UWAGA funkcja pn532.read_mifare() jest blokująca) :
```python
from py532lib.i2c import *
from py532lib.frame import *
from py532lib.constants import *

pn532 = Pn532_i2c(i2c_channel=9)
pn532.SAMconfigure()

while(True):
    card_data = pn532.read_mifare().get_data()
    print(card_data)
```
![Test odczytu kart NFC w app python](lab03-i2c/img/PN532_python_test.gif "Test odczytu kart NFC w app python")
- Przykładowy kod programu (UWAGA funkcja card.scan_field() jest nieblokująca) :
```python
#!/usr/bin/env python3.6
from py532lib.mifare import *
from py532lib.frame import *
from py532lib.constants import *
import time

card = Mifare()
card.i2c_channel=9
card.reset_i2c()
# Configure the PN532 for the number of retries attempted
# during the InListPassiveTarget operation (set to
# MIFARE_SAFE_RETRIES=5 for a safe one-time check
card.set_max_retries(MIFARE_SAFE_RETRIES)
#Send a SAMCONFIGURATION (Secure Access Module) command to the PN532 
card.SAMconfigure()
while(True):
    uuid = card.scan_field()
    if uuid:
        print(uuid)
        address = card.mifare_address(0,1)
        card.mifare_auth_a(address,MIFARE_FACTORY_KEY)
        data = card.mifare_read(address)
        print(data)
        card.in_deselect() # In case you want to authorize a different sector.
    elif(int(time.time())%5==0):
        print("Not find any new tag, wait for next 5 sec...")
        sleep(1)
```
### Zadania (10pkt.):
 - Dodać obsługę czytnika NFC do MQTT - aplikacja nfcReader.py (topic 'sensors/nfc') (2pkt.) 
 - Zmienić diodę zielona LED (GPIO504) na ON (na 5s) kiedy odczyta znaną kartę NFC, zapal czerowną LED (GPIO505) w reakcji na inne karty- aplikacja recvNfc.py odbiera wiadomości z topic 'sensors/nfc' i ustawia diode w topicu 'led/504' oraz 'led/505' (4pkt.)
 - j.w włączyć/wyłączyć diodę na innym NUCDevKit (1pkt.)
 - wyświetlić tabele z odczytami UUID NFC kart w grafanie (konfiguracja telegraf.conf oraz dashbord grafany panel "table") (3pkt.)
