## Czytnik NFC

Sprawdz switch 
![Schemat połączenia czytnika NFC z NUC](lab03-uart/img/lab2_nfc.png "Schemat połączenia czytnika NFC z NUC")
- Sprawdzenie poprawnej komunikacji z NF532 na interfejsie UART
```bash
cat /etc/nfc/libnfc.conf
nfc-list
nfc-poll
``` 
Zawartość pliku /etc/nfc/libnfc.conf
````bash
device.name = "PN532 board via UART"
device.connstring = "pn532_uart:/dev/ttyUSB0"
````
Po uruchomieniu komendy 'nfc-pool' przyłóż kartę NFC do czytnika (włącz obracanie ramienia z kartami NFC), powinien wyświetlić się UID karty. Zapamiętajcie to UID na potem. (część animacji poniżej jest dla i2c, zwróćcie uwagę tylko na nfc-poll i nfc-list)
![Test połączenia czytnika NFC z NUC](lab03-uart/img/PN532_testS.gif "Test połączenia czytnika NFC z NUC")

### Obsługa czytnika w Pythonie:
Znalezienie dobrej obsługi każdego możliwego urządzenia w każdym możliwym języku może nie być proste. Jest jedno repo z obsługą naszego czytnika na uart w Pythonie. Spróbujmy przeanalizować jego kod i dostosować go do naszych potrzeb.
Stwórzcie folder i ściągnijcie repo:
````bash
git clone https://github.com/innomatica/pylibnfc
````

Otwórzcie example.py i zmieńcie UID w keyTagId na UID waszej karty. Zaobserwujcie co się dzieje.

### Zadania (10pkt.):
 - Pobrany przykład odoczytuję kartę tylko jednokrotnie. Zmieńcie kod tak by czytał kartę ciągle (3pkt.)
 - Dodać obsługę czytnika NFC do MQTT - aplikacja nfcReader.py (topic 'sensors/nfc') (2pkt.) 
 - Zmienić diodę zielona LED (GPIO504) na ON (na 5s) kiedy odczyta znaną kartę NFC, zapal czerowną LED (GPIO505) w reakcji na inne karty- aplikacja recvNfc.py odbiera wiadomości z topic 'sensors/nfc' i ustawia diode w topicu 'led/504' oraz 'led/505' (2pkt.)
 - j.w włączyć/wyłączyć diodę na innym NUCDevKit (1pkt.)
 - wyświetlić tabele z odczytami UUID NFC kart w grafanie (konfiguracja telegraf.conf oraz dashbord grafany panel "table") (2pkt.)
